org.objectweb.asm.commons

## Class AdviceAdapter

- java.lang.Object
- - org.objectweb.asm.MethodVisitor
  - - org.objectweb.asm.commons.LocalVariablesSorter
    - - org.objectweb.asm.commons.GeneratorAdapter
      - - org.objectweb.asm.commons.AdviceAdapter

- All Implemented Interfaces:
    Opcodes

      public abstract class AdviceAdapter
      extends GeneratorAdapter
      implements Opcodes

  A `MethodVisitor` to insert before, after and around advices in methods and constructors.

  The behavior for constructors is like this:

  1. as long as the INVOKESPECIAL for the object initialization has not been reached, every bytecode instruction is dispatched in the ctor code visitor
  2. when this one is reached, it is only added in the ctor code visitor and a JP invoke is added
  3. after that, only the other code visitor receives the instructions
  Author:
    Eugene Kuleshov, Eric Bruneton

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected int` | `methodAccess`
    `protected String` | `methodDesc`

    - ### Fields inherited from class org.objectweb.asm.commons.GeneratorAdapter

      `ADD, AND, DIV, EQ, GE, GT, LE, LT, MUL, NE, NEG, OR, REM, SHL, SHR, SUB, USHR, XOR`

    - ### Fields inherited from class org.objectweb.asm.commons.LocalVariablesSorter

      `firstLocal, nextLocal`

    - ### Fields inherited from class org.objectweb.asm.MethodVisitor

      `api, mv`

    - ### Fields inherited from interface org.objectweb.asm.Opcodes

      `AALOAD, AASTORE, ACC_ABSTRACT, ACC_ANNOTATION, ACC_BRIDGE, ACC_DEPRECATED, ACC_ENUM, ACC_FINAL, ACC_INTERFACE, ACC_MANDATED, ACC_NATIVE, ACC_PRIVATE, ACC_PROTECTED, ACC_PUBLIC, ACC_STATIC, ACC_STRICT, ACC_SUPER, ACC_SYNCHRONIZED, ACC_SYNTHETIC, ACC_TRANSIENT, ACC_VARARGS, ACC_VOLATILE, ACONST_NULL, ALOAD, ANEWARRAY, ARETURN, ARRAYLENGTH, ASM4, ASM5, ASTORE, ATHROW, BALOAD, BASTORE, BIPUSH, CALOAD, CASTORE, CHECKCAST, D2F, D2I, D2L, DADD, DALOAD, DASTORE, DCMPG, DCMPL, DCONST_0, DCONST_1, DDIV, DLOAD, DMUL, DNEG, DOUBLE, DREM, DRETURN, DSTORE, DSUB, DUP, DUP_X1, DUP_X2, DUP2, DUP2_X1, DUP2_X2, F_APPEND, F_CHOP, F_FULL, F_NEW, F_SAME, F_SAME1, F2D, F2I, F2L, FADD, FALOAD, FASTORE, FCMPG, FCMPL, FCONST_0, FCONST_1, FCONST_2, FDIV, FLOAD, FLOAT, FMUL, FNEG, FREM, FRETURN, FSTORE, FSUB, GETFIELD, GETSTATIC, GOTO, H_GETFIELD, H_GETSTATIC, H_INVOKEINTERFACE, H_INVOKESPECIAL, H_INVOKESTATIC, H_INVOKEVIRTUAL, H_NEWINVOKESPECIAL, H_PUTFIELD, H_PUTSTATIC, I2B, I2C, I2D, I2F, I2L, I2S, IADD, IALOAD, IAND, IASTORE, ICONST_0, ICONST_1, ICONST_2, ICONST_3, ICONST_4, ICONST_5, ICONST_M1, IDIV, IF_ACMPEQ, IF_ACMPNE, IF_ICMPEQ, IF_ICMPGE, IF_ICMPGT, IF_ICMPLE, IF_ICMPLT, IF_ICMPNE, IFEQ, IFGE, IFGT, IFLE, IFLT, IFNE, IFNONNULL, IFNULL, IINC, ILOAD, IMUL, INEG, INSTANCEOF, INTEGER, INVOKEDYNAMIC, INVOKEINTERFACE, INVOKESPECIAL, INVOKESTATIC, INVOKEVIRTUAL, IOR, IREM, IRETURN, ISHL, ISHR, ISTORE, ISUB, IUSHR, IXOR, JSR, L2D, L2F, L2I, LADD, LALOAD, LAND, LASTORE, LCMP, LCONST_0, LCONST_1, LDC, LDIV, LLOAD, LMUL, LNEG, LONG, LOOKUPSWITCH, LOR, LREM, LRETURN, LSHL, LSHR, LSTORE, LSUB, LUSHR, LXOR, MONITORENTER, MONITOREXIT, MULTIANEWARRAY, NEW, NEWARRAY, NOP, NULL, POP, POP2, PUTFIELD, PUTSTATIC, RET, RETURN, SALOAD, SASTORE, SIPUSH, SWAP, T_BOOLEAN, T_BYTE, T_CHAR, T_DOUBLE, T_FLOAT, T_INT, T_LONG, T_SHORT, TABLESWITCH, TOP, UNINITIALIZED_THIS, V1_1, V1_2, V1_3, V1_4, V1_5, V1_6, V1_7, V1_8`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `protected` | `AdviceAdapter(int api, MethodVisitor mv, int access, String name, String desc)` Creates a new `AdviceAdapter`.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods Deprecated Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected void` | `onMethodEnter()` Called at the beginning of the method or after super class call in the constructor.
    `protected void` | `onMethodExit(int opcode)` Called before explicit exit from the method using either return or throw.
    `void` | `visitCode()` Starts the visit of the method's code, if any (i.e. non abstract method).
    `void` | `visitFieldInsn(int opcode, String owner, String name, String desc)` Visits a field instruction.
    `void` | `visitInsn(int opcode)` Visits a zero operand instruction.
    `void` | `visitIntInsn(int opcode, int operand)` Visits an instruction with a single int operand.
    `void` | `visitInvokeDynamicInsn(String name, String desc, Handle bsm, Object... bsmArgs)` Visits an invokedynamic instruction.
    `void` | `visitJumpInsn(int opcode, Label label)` Visits a jump instruction.
    `void` | `visitLabel(Label label)` Visits a label.
    `void` | `visitLdcInsn(Object cst)` Visits a LDC instruction.
    `void` | `visitLookupSwitchInsn(Label dflt, int[] keys, Label[] labels)` Visits a LOOKUPSWITCH instruction.
    `void` | `visitMethodInsn(int opcode, String owner, String name, String desc)` Deprecated.
    `void` | `visitMethodInsn(int opcode, String owner, String name, String desc, boolean itf)` Visits a method instruction.
    `void` | `visitMultiANewArrayInsn(String desc, int dims)` Visits a MULTIANEWARRAY instruction.
    `void` | `visitTableSwitchInsn(int min, int max, Label dflt, Label... labels)` Visits a TABLESWITCH instruction.
    `void` | `visitTryCatchBlock(Label start, Label end, Label handler, String type)` Visits a try catch block.
    `void` | `visitTypeInsn(int opcode, String type)` Visits a type instruction.
    `void` | `visitVarInsn(int opcode, int var)` Visits a local variable instruction.

    - ### Methods inherited from class org.objectweb.asm.commons.GeneratorAdapter

      `arrayLength, arrayLoad, arrayStore, box, cast, catchException, checkCast, dup, dup2, dup2X1, dup2X2, dupX1, dupX2, endMethod, getField, getLocalType, getStatic, goTo, ifCmp, ifICmp, ifNonNull, ifNull, ifZCmp, iinc, instanceOf, invokeConstructor, invokeDynamic, invokeInterface, invokeStatic, invokeVirtual, loadArg, loadArgArray, loadArgs, loadArgs, loadLocal, loadLocal, loadThis, mark, mark, math, monitorEnter, monitorExit, newArray, newInstance, newLabel, not, pop, pop2, push, push, push, push, push, push, push, push, putField, putStatic, ret, returnValue, setLocalType, storeArg, storeLocal, storeLocal, swap, swap, tableSwitch, tableSwitch, throwException, throwException, unbox, valueOf`

    - ### Methods inherited from class org.objectweb.asm.commons.LocalVariablesSorter

      `newLocal, newLocalMapping, updateNewLocals, visitFrame, visitIincInsn, visitLocalVariable, visitLocalVariableAnnotation, visitMaxs`

    - ### Methods inherited from class org.objectweb.asm.MethodVisitor

      `visitAnnotation, visitAnnotationDefault, visitAttribute, visitEnd, visitInsnAnnotation, visitLineNumber, visitParameter, visitParameterAnnotation, visitTryCatchAnnotation, visitTypeAnnotation`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### methodAccess

          protected int methodAccess

    - #### methodDesc

          protected String methodDesc

  - ### Constructor Detail

    - #### AdviceAdapter

          protected AdviceAdapter(int api,
                                  MethodVisitor mv,
                                  int access,
                                  String name,
                                  String desc)

      Creates a new `AdviceAdapter`.
      Parameters:
        `api` - the ASM API version implemented by this visitor. Must be one of `Opcodes.ASM4` or `Opcodes.ASM5`.
        `mv` - the method visitor to which this adapter delegates calls.
        `access` - the method's access flags (see `Opcodes`).
        `name` - the method's name.
        `desc` - the method's descriptor (see `Type`).

  - ### Method Detail

    - #### visitCode

          public void visitCode()

      Description copied from class: `MethodVisitor`
      Starts the visit of the method's code, if any (i.e. non abstract method).
      Overrides:
        `visitCode` in class `MethodVisitor`

    - #### visitLabel

          public void visitLabel(Label label)

      Description copied from class: `MethodVisitor`
      Visits a label. A label designates the instruction that will be visited just after it.
      Overrides:
        `visitLabel` in class `MethodVisitor`
      Parameters:
        `label` - a `Label` object.

    - #### visitInsn

          public void visitInsn(int opcode)

      Description copied from class: `MethodVisitor`
      Visits a zero operand instruction.
      Overrides:
        `visitInsn` in class `MethodVisitor`
      Parameters:
        `opcode` - the opcode of the instruction to be visited. This opcode is either NOP, ACONST_NULL, ICONST_M1, ICONST_0, ICONST_1, ICONST_2, ICONST_3, ICONST_4, ICONST_5, LCONST_0, LCONST_1, FCONST_0, FCONST_1, FCONST_2, DCONST_0, DCONST_1, IALOAD, LALOAD, FALOAD, DALOAD, AALOAD, BALOAD, CALOAD, SALOAD, IASTORE, LASTORE, FASTORE, DASTORE, AASTORE, BASTORE, CASTORE, SASTORE, POP, POP2, DUP, DUP_X1, DUP_X2, DUP2, DUP2_X1, DUP2_X2, SWAP, IADD, LADD, FADD, DADD, ISUB, LSUB, FSUB, DSUB, IMUL, LMUL, FMUL, DMUL, IDIV, LDIV, FDIV, DDIV, IREM, LREM, FREM, DREM, INEG, LNEG, FNEG, DNEG, ISHL, LSHL, ISHR, LSHR, IUSHR, LUSHR, IAND, LAND, IOR, LOR, IXOR, LXOR, I2L, I2F, I2D, L2I, L2F, L2D, F2I, F2L, F2D, D2I, D2L, D2F, I2B, I2C, I2S, LCMP, FCMPL, FCMPG, DCMPL, DCMPG, IRETURN, LRETURN, FRETURN, DRETURN, ARETURN, RETURN, ARRAYLENGTH, ATHROW, MONITORENTER, or MONITOREXIT.

    - #### visitVarInsn

          public void visitVarInsn(int opcode,
                                   int var)

      Description copied from class: `MethodVisitor`
      Visits a local variable instruction. A local variable instruction is an instruction that loads or stores the value of a local variable.
      Overrides:
        `visitVarInsn` in class `LocalVariablesSorter`
      Parameters:
        `opcode` - the opcode of the local variable instruction to be visited. This opcode is either ILOAD, LLOAD, FLOAD, DLOAD, ALOAD, ISTORE, LSTORE, FSTORE, DSTORE, ASTORE or RET.
        `var` - the operand of the instruction to be visited. This operand is the index of a local variable.

    - #### visitFieldInsn

          public void visitFieldInsn(int opcode,
                                     String owner,
                                     String name,
                                     String desc)

      Description copied from class: `MethodVisitor`
      Visits a field instruction. A field instruction is an instruction that loads or stores the value of a field of an object.
      Overrides:
        `visitFieldInsn` in class `MethodVisitor`
      Parameters:
        `opcode` - the opcode of the type instruction to be visited. This opcode is either GETSTATIC, PUTSTATIC, GETFIELD or PUTFIELD.
        `owner` - the internal name of the field's owner class (see `getInternalName`).
        `name` - the field's name.
        `desc` - the field's descriptor (see `Type`).

    - #### visitIntInsn

          public void visitIntInsn(int opcode,
                                   int operand)

      Description copied from class: `MethodVisitor`
      Visits an instruction with a single int operand.
      Overrides:
        `visitIntInsn` in class `MethodVisitor`
      Parameters:
        `opcode` - the opcode of the instruction to be visited. This opcode is either BIPUSH, SIPUSH or NEWARRAY.
        `operand` - the operand of the instruction to be visited.
        When opcode is BIPUSH, operand value should be between Byte.MIN_VALUE and Byte.MAX_VALUE.
        When opcode is SIPUSH, operand value should be between Short.MIN_VALUE and Short.MAX_VALUE.
        When opcode is NEWARRAY, operand value should be one of `Opcodes.T_BOOLEAN`, `Opcodes.T_CHAR`, `Opcodes.T_FLOAT`, `Opcodes.T_DOUBLE`, `Opcodes.T_BYTE`, `Opcodes.T_SHORT`, `Opcodes.T_INT` or `Opcodes.T_LONG`.

    - #### visitLdcInsn

          public void visitLdcInsn(Object cst)

      Description copied from class: `MethodVisitor`
      Visits a LDC instruction. Note that new constant types may be added in future versions of the Java Virtual Machine. To easily detect new constant types, implementations of this method should check for unexpected constant types, like this:

           if (cst instanceof Integer) {
               // ...
           } else if (cst instanceof Float) {
               // ...
           } else if (cst instanceof Long) {
               // ...
           } else if (cst instanceof Double) {
               // ...
           } else if (cst instanceof String) {
               // ...
           } else if (cst instanceof Type) {
               int sort = ((Type) cst).getSort();
               if (sort == Type.OBJECT) {
                   // ...
               } else if (sort == Type.ARRAY) {
                   // ...
               } else if (sort == Type.METHOD) {
                   // ...
               } else {
                   // throw an exception
               }
           } else if (cst instanceof Handle) {
               // ...
           } else {
               // throw an exception
           }

      Overrides:
        `visitLdcInsn` in class `MethodVisitor`
      Parameters:
        `cst` - the constant to be loaded on the stack. This parameter must be a non null `Integer`, a `Float`, a `Long`, a `Double`, a `String`, a `Type` of OBJECT or ARRAY sort for `.class` constants, for classes whose version is 49.0, a `Type` of METHOD sort or a `Handle` for MethodType and MethodHandle constants, for classes whose version is 51.0.

    - #### visitMultiANewArrayInsn

          public void visitMultiANewArrayInsn(String desc,
                                              int dims)

      Description copied from class: `MethodVisitor`
      Visits a MULTIANEWARRAY instruction.
      Overrides:
        `visitMultiANewArrayInsn` in class `MethodVisitor`
      Parameters:
        `desc` - an array type descriptor (see `Type`).
        `dims` - number of dimensions of the array to allocate.

    - #### visitTypeInsn

          public void visitTypeInsn(int opcode,
                                    String type)

      Description copied from class: `MethodVisitor`
      Visits a type instruction. A type instruction is an instruction that takes the internal name of a class as parameter.
      Overrides:
        `visitTypeInsn` in class `MethodVisitor`
      Parameters:
        `opcode` - the opcode of the type instruction to be visited. This opcode is either NEW, ANEWARRAY, CHECKCAST or INSTANCEOF.
        `type` - the operand of the instruction to be visited. This operand must be the internal name of an object or array class (see `getInternalName`).

    - #### visitMethodInsn

          @Deprecated
          public void visitMethodInsn(int opcode,
                                                   String owner,
                                                   String name,
                                                   String desc)

      Deprecated.
      Description copied from class: `MethodVisitor`
      Visits a method instruction. A method instruction is an instruction that invokes a method.
      Overrides:
        `visitMethodInsn` in class `MethodVisitor`
      Parameters:
        `opcode` - the opcode of the type instruction to be visited. This opcode is either INVOKEVIRTUAL, INVOKESPECIAL, INVOKESTATIC or INVOKEINTERFACE.
        `owner` - the internal name of the method's owner class (see `getInternalName`).
        `name` - the method's name.
        `desc` - the method's descriptor (see `Type`).

    - #### visitMethodInsn

          public void visitMethodInsn(int opcode,
                                      String owner,
                                      String name,
                                      String desc,
                                      boolean itf)

      Description copied from class: `MethodVisitor`
      Visits a method instruction. A method instruction is an instruction that invokes a method.
      Overrides:
        `visitMethodInsn` in class `MethodVisitor`
      Parameters:
        `opcode` - the opcode of the type instruction to be visited. This opcode is either INVOKEVIRTUAL, INVOKESPECIAL, INVOKESTATIC or INVOKEINTERFACE.
        `owner` - the internal name of the method's owner class (see `getInternalName`).
        `name` - the method's name.
        `desc` - the method's descriptor (see `Type`).
        `itf` - if the method's owner class is an interface.

    - #### visitInvokeDynamicInsn

          public void visitInvokeDynamicInsn(String name,
                                             String desc,
                                             Handle bsm,
                                             Object... bsmArgs)

      Description copied from class: `MethodVisitor`
      Visits an invokedynamic instruction.
      Overrides:
        `visitInvokeDynamicInsn` in class `MethodVisitor`
      Parameters:
        `name` - the method's name.
        `desc` - the method's descriptor (see `Type`).
        `bsm` - the bootstrap method.
        `bsmArgs` - the bootstrap method constant arguments. Each argument must be an `Integer`, `Float`, `Long`, `Double`, `String`, `Type` or `Handle` value. This method is allowed to modify the content of the array so a caller should expect that this array may change.

    - #### visitJumpInsn

          public void visitJumpInsn(int opcode,
                                    Label label)

      Description copied from class: `MethodVisitor`
      Visits a jump instruction. A jump instruction is an instruction that may jump to another instruction.
      Overrides:
        `visitJumpInsn` in class `MethodVisitor`
      Parameters:
        `opcode` - the opcode of the type instruction to be visited. This opcode is either IFEQ, IFNE, IFLT, IFGE, IFGT, IFLE, IF_ICMPEQ, IF_ICMPNE, IF_ICMPLT, IF_ICMPGE, IF_ICMPGT, IF_ICMPLE, IF_ACMPEQ, IF_ACMPNE, GOTO, JSR, IFNULL or IFNONNULL.
        `label` - the operand of the instruction to be visited. This operand is a label that designates the instruction to which the jump instruction may jump.

    - #### visitLookupSwitchInsn

          public void visitLookupSwitchInsn(Label dflt,
                                            int[] keys,
                                            Label[] labels)

      Description copied from class: `MethodVisitor`
      Visits a LOOKUPSWITCH instruction.
      Overrides:
        `visitLookupSwitchInsn` in class `MethodVisitor`
      Parameters:
        `dflt` - beginning of the default handler block.
        `keys` - the values of the keys.
        `labels` - beginnings of the handler blocks. `labels[i]` is the beginning of the handler block for the `keys[i]` key.

    - #### visitTableSwitchInsn

          public void visitTableSwitchInsn(int min,
                                           int max,
                                           Label dflt,
                                           Label... labels)

      Description copied from class: `MethodVisitor`
      Visits a TABLESWITCH instruction.
      Overrides:
        `visitTableSwitchInsn` in class `MethodVisitor`
      Parameters:
        `min` - the minimum key value.
        `max` - the maximum key value.
        `dflt` - beginning of the default handler block.
        `labels` - beginnings of the handler blocks. `labels[i]` is the beginning of the handler block for the `min + i` key.

    - #### visitTryCatchBlock

          public void visitTryCatchBlock(Label start,
                                         Label end,
                                         Label handler,
                                         String type)

      Description copied from class: `MethodVisitor`
      Visits a try catch block.
      Overrides:
        `visitTryCatchBlock` in class `MethodVisitor`
      Parameters:
        `start` - beginning of the exception handler's scope (inclusive).
        `end` - end of the exception handler's scope (exclusive).
        `handler` - beginning of the exception handler's code.
        `type` - internal name of the type of exceptions handled by the handler, or `null` to catch any exceptions (for "finally" blocks).

    - #### onMethodEnter

          protected void onMethodEnter()

      Called at the beginning of the method or after super class call in the constructor.
      Custom code can use or change all the local variables, but should not change state of the stack.

    - #### onMethodExit

          protected void onMethodExit(int opcode)

      Called before explicit exit from the method using either return or throw. Top element on the stack contains the return value or exception instance. For example:

             public void onMethodExit(int opcode) {
               if(opcode==RETURN) {
                   visitInsn(ACONST_NULL);
               } else if(opcode==ARETURN || opcode==ATHROW) {
                   dup();
               } else {
                   if(opcode==LRETURN || opcode==DRETURN) {
                       dup2();
                   } else {
                       dup();
                   }
                   box(Type.getReturnType(this.methodDesc));
               }
               visitIntInsn(SIPUSH, opcode);
               visitMethodInsn(INVOKESTATIC, owner, "onExit", "(Ljava/lang/Object;I)V");
             }

             // an actual call back method
             public static void onExit(Object param, int opcode) {
               ...

      Custom code can use or change all the local variables, but should not change state of the stack.
      Parameters:
        `opcode` - one of the RETURN, IRETURN, FRETURN, ARETURN, LRETURN, DRETURN or ATHROW